----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    17:02:26 12/06/2011 
-- Design Name: 
-- Module Name:    smachine - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity smachine is
    Port ( sysclk : in  STD_LOGIC;
           reset : in  STD_LOGIC;
           LED_N : out  STD_LOGIC;
           LED_E : out  STD_LOGIC;
           LED_S : out  STD_LOGIC;
           LED_W : out  STD_LOGIC;
           LED_C : out  STD_LOGIC);
end smachine;

architecture Behavioral of smachine is

signal count25 : std_logic_vector(24 downto 0);
signal en05    : std_logic;
--
signal led_state : std_logic_vector(2 downto 0);

begin

-- 22bit counter
process (sysclk, reset) begin
if (reset = '0') then
    count25 <= "0000000000000000000000000";
elsif (sysclk'event and sysclk = '1') then
    count25 <= count25 + '1';
end if;
end process;

-- en05 signal hassei
process(count25) begin
if (count25 = "1111111111111111111111111") then
    en05 <= '1';
else
    en05 <= '0';
end if;
end process;

-- led state machine
process (sysclk, reset) begin
if (reset = '0') then
    led_state <= "000";
elsif (sysclk'event and sysclk ='1') then
    if (en05 = '1') then
	     if (led_state = "100") then
		      led_state <= "000";
		  else
			   led_state <= led_state + '1';
        end if;				
	 end if;
end if;
end process;

-- generate LED_* outputs
process (led_state) begin
 case led_state is
   when "000" => LED_C<='1'; LED_W<='0'; LED_S<='0'; LED_E<='0'; LED_N<='0';
	when "001" => LED_C<='0'; LED_W<='1'; LED_S<='0'; LED_E<='0'; LED_N<='0';
	when "010" => LED_C<='0'; LED_W<='0'; LED_S<='1'; LED_E<='0'; LED_N<='0';
	when "011" => LED_C<='0'; LED_W<='0'; LED_S<='0'; LED_E<='1'; LED_N<='0';
	when "100" => LED_C<='0'; LED_W<='0'; LED_S<='0'; LED_E<='0'; LED_N<='1';
	when others=> LED_C<='0'; LED_W<='0'; LED_S<='0'; LED_E<='0'; LED_N<='0';
 end case;
end process;

end Behavioral;

